Program RAYPAS;
{
  Sample Raytracing program v2
  Copyright (C) 1998  Paul Toth

  TothPaul@multimania.com
  http://www.multimania.com/tothpaul

  Thanks to Cyrille FAVREAU for is Delphi RayTracer !
  http://www.multimania.com/cfavreau

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

{$N+,E-}

Uses
 Render,Scenes;

Var
 Scene :TScene;  { collection of 3D object }
 Lamp  :TLamp;   { a light source }
 Sphere:TSphere; { a 3D object }
 Screen:TRender; { the screen  }

 s2:TSphere;
 s3:TSphere;

 s4,s5:TSphere;

 s6:TSphere;

begin
 Scene.Create;         { create a scene ...}

 Lamp.Create(Scene);
 Lamp.Brightness:=0.50;

 Sphere.Create(Scene); { ... with a sphere ... }
 Sphere.Radius:=90;
 Sphere.Reflection:=0.10;
 Sphere.Transparency:=0.40;

 s2.Create(Scene);
 s2.Center.x:=+200;
 s2.Color.R:=0;
 s2.Color.G:=0;
 s2.Color.B:=255;

 s3.Create(Scene);
 s3.Center.x:=+100;
 s3.Center.y:=-150;
 s3.Center.z:=+200;
 s3.Color.R:=255;
 s3.Color.G:=255;
 s3.Color.B:=0;
 s3.Reflection:=0.95;

 s4.Create(Scene);
 s4.Center.x:=-200;
 s4.Color.R:=255;
 s4.Color.G:=0;
 s4.Color.B:=0;
 s4.Reflection:=0.30;

 s5.Create(Scene);
 s5.Center.x:=-100;
 s5.Center.y:=-150;
 s5.Center.z:=+200;
 s5.Color.R:=0;
 s5.Color.G:=255;
 s5.Color.B:=0;

 s6.Create(Scene);
 s6.Radius:=200;
 s6.Center.y:=+300;
 s6.Reflection:=1;
 s6.Brightness:=0.50;

 Screen.Create;         { create a render ... }
  Scene.DrawXZ(Screen); { ... to display the scene }
  Scene.RayXZ(Screen,-50);
  Scene.RayXZ(Screen,+110);
  ReadLn;
  Screen.Clear;

  Scene.Draw3D(Screen);
  Readln;

  Screen.SaveToFile('RAYPAS.BMP');

 Screen.Destroy;       { Restore CRT Mode }
end.